14e4:4365 bcmwl-kernel source: fix for null pointer crash

Bug #1415880 reported by Andre Bogus on 2015-01-29
382
This bug affects 74 people
Affects Status Importance Assigned to Milestone
Dell Sputnik
Undecided
Unassigned
bcmwl (Ubuntu)
High
Rafael David Tinoco
Nominated for Trusty by Mathew Hodson
Precise
High
Rafael David Tinoco
Trusty
High
Unassigned
Vivid
High
Rafael David Tinoco
Wily
High
Rafael David Tinoco

Bug Description

[Impact]

 * bcmwl does not compile on new kernels (or HWE kernels)
 * bcmwl suffers from null reference bug

[Test Case]

 * public PPA provided to community and feedback
 * based on patch available to other distros
 * comment #42

[Regression Potential]

 * for changes on kernel support it may not compile (tested with 3.2, 3.13, 3.18 and 4.2)
 * for the null reference change -> proved to fix problem for community based on feedback

[Other Info]

Original bug description:

The bcmwl package as of now misses one patch for a bug that occurs with BCM43142 and possibly other broadcom chipsets that will look like random disconnects, poor wifi signal and kernel warnings, See also #1379524.

Adding the patch is a fairly simple process:

* put the patch file in /usr/src/bcmwl-6.30.223.248+bdcom/patches
* add the following line to /usr/src/bcmwl-6.30.223.248+bdcom/dkms.conf
PATCH[7]="0014-null-pointer-crash.patch"
* run: /usr/lib/dkms/common.postinst bcmwl 6.30.223.248+bdcom /usr/share/bcmwl x86_64 $(uname -r)

This has fixed the issue for me. Edit: I just wanted to add that I did not write the patch; I merely downloaded it from a paste that was linked from the respective AUR package.

ProblemType: Bug
DistroRelease: Ubuntu 14.10
Package: bcmwl-kernel-source 6.30.223.248+bdcom-0ubuntu1 [modified: usr/src/bcmwl-6.30.223.248+bdcom/dkms.conf]
ProcVersionSignature: Ubuntu 3.16.0-29.39-generic 3.16.7-ckt2
Uname: Linux 3.16.0-29-generic x86_64
NonfreeKernelModules: wl
ApportVersion: 2.14.7-0ubuntu8.1
Architecture: amd64
CurrentDesktop: LXDE
Date: Thu Jan 29 13:15:17 2015
InstallationDate: Installed on 2015-01-26 (3 days ago)
InstallationMedia: Lubuntu 14.10 "Utopic Unicorn" - Release amd64 (20141022.1)
SourcePackage: bcmwl
UpgradeStatus: No upgrade log present (probably fresh install)

Andre Bogus (bogusandre) wrote :
Andre Bogus (bogusandre) on 2015-01-29
description: updated

The attachment "Patch to fix the null pointer crash that happens with BCM43142 (and possibly other) chipsets" seems to be a patch. If it isn't, please remove the "patch" flag from the attachment, remove the "patch" tag, and if you are a member of the ~ubuntu-reviewers, unsubscribe the team.

[This is an automated message performed by a Launchpad user owned by ~brian-murray, for any issues please contact him.]

tags: added: patch

Andre Bogus, thank you for reporting this and helping make Ubuntu better. Could you please provide the missing information from https://help.ubuntu.com/community/WifiDocs/Driver/bcm43xx#Broadcom_STA_Wireless_driver ?

Changed in bcmwl (Ubuntu):
importance: Undecided → High
status: New → Incomplete
Andre Bogus (bogusandre) wrote :

Hi again,

here is the output of the referenced commands:

$ apt-cache policy bcmwl-kernel-source
bcmwl-kernel-source:
  Installiert: 6.30.223.248+bdcom-0ubuntu1
  Installationskandidat: 6.30.223.248+bdcom-0ubuntu1
  Versionstabelle:
 *** 6.30.223.248+bdcom-0ubuntu1 0
        500 http://ftp.uni-stuttgart.de/ubuntu/ utopic/restricted amd64 Packages
        100 /var/lib/dpkg/status

$ lspci -vvnn | grep -A 9 Network
02:00.0 Network controller [0280]: Broadcom Corporation BCM43142 802.11b/g/n [14e4:4365] (rev 01)
 Subsystem: Lenovo Device [17aa:0611]
 Control: I/O- Mem+ BusMaster+ SpecCycle- MemWINV- VGASnoop- ParErr- Stepping- SERR- FastB2B- DisINTx-
 Status: Cap+ 66MHz- UDF- FastB2B- ParErr- DEVSEL=fast >TAbort- <TAbort- <MAbort- >SERR- <PERR- INTx-
 Latency: 0, Cache Line Size: 64 bytes
 Interrupt: pin A routed to IRQ 16
 Region 0: Memory at b0500000 (64-bit, non-prefetchable) [size=32K]
 Capabilities: <access denied>
 Kernel driver in use: wl

$ lsb_release -rd
Description: Ubuntu 14.10
Release: 14.10

$ uname -a
Linux Z510 3.16.0-29-generic #39-Ubuntu SMP Mon Dec 15 22:27:29 UTC 2014 x86_64 x86_64 x86_64 GNU/Linux

$ sudo dmidecode -s bios-version
8DCN38WW

Changed in bcmwl (Ubuntu):
status: Incomplete → Confirmed
tags: added: bios-outdated-8dcn40ww

Andre Bogus, just to clarify, is this patch required for Vivid as well?

Changed in bcmwl (Ubuntu):
status: Confirmed → Incomplete
Andre Bogus (bogusandre) wrote :

Christopher Penalver,

I'm not sure, I'm still on Utopic, but I'm currently downloading the alpha2 ISO; I'm going to inform you once I have tested. Also I have to report that the 'fix' is apparently not fully effective; yesterday the problem reappeared. Regarding the outdated BIOS; I could perhaps borrow a Windows 7 to update the BIOS (alas, Lenovo does not ship the IdeaPad BIOS update in a format that can be managed with Linux tools). Or would you like me to continue testing with the original BIOS?

1 comments hidden view all 101 comments
Brian Burch (brian-pingtoo) wrote :

I have been running 6.30.223.248+bdcom-0ubuntu1 on trusty 14.04.1 LTS for several weeks.

I applied the patch suggested by Andre yesterday, and haven't seen any kernel crashes yet. However, I am still seeing occasional (once per hour approx) loss of connectivity. A typical syslog extract is below:

Feb 2 23:47:12 bacchus wpa_supplicant[1287]: message repeated 25 times: [ wlan0: CTRL-EVENT-SCAN-STARTED ]
Feb 2 23:48:50 bacchus wpa_supplicant[1287]: wlan0: WPA: Group rekeying completed with 00:12:0e:54:e9:a4 [GTK=CCMP]
Feb 2 23:49:12 bacchus wpa_supplicant[1287]: wlan0: CTRL-EVENT-SCAN-STARTED
Feb 3 00:03:12 bacchus kernel: [ 3848.216125] ERROR @wl_notify_scan_status : wlan0 Scan_results error (-22)
Feb 3 00:07:12 bacchus kernel: [ 4088.258526] ERROR @wl_notify_scan_status : wlan0 Scan_results error (-22)

I have just checked the syslog and the error was also being logged prior to applying the patch. I wonder whether this error is relevant to this bug - sorry if it isn't.

summary: - bcmwl-kernel source: fix for null pointer crash
+ 14e4:4365 bcmwl-kernel source: fix for null pointer crash
Brian Burch (brian-pingtoo) wrote :

I need advice on whether I should be opening a new bug, or is it OK to stay with this one?

On further investigation, I have noticed three things:

1. The current trusty repository bcmwl-kernel-source 6.30.223.141+bdcom-0ubuntu2 is used on my wife's laptop. This system is not experiencing null pointer crashes OR Scan_results errors. This evidence strongly suggests both problems were introduced with 6.30.223.248+bdcom-0ubuntu1.

2. On checking syslog carefully, the Scan_results errors are often associated with the system running slowly and "[TTM] Out of kernel memory" messages being logged. The "victim" is the ATI radeon drm driver, but I suspect the bcmwl scan errors are causing the driver to not release kernel memory it has used for its wlan scan. Usually, I have to reboot the system to restore normal performance. I have attached an appropriate syslog extract. (note: when searching for these display-related messages I hit very old bugs that were never explicitly resolved).

3. I turned wifi off 12 hours ago and have been running the system via its ethernet adapter (incidentally, also from Broadcom). Syslog doesn't contain ANY "out of kernel memory" errors and system performance is back to normal and stable.

Brian Burch, as you have a different WiFi chipset and underlying hardware as the original reporter, it would be best for now to comment in the report you already made.

Andre Bogus (bogusandre) wrote :

Hi again,

this took some time. I had to dig up a Windows 7 Rescue CD from somewhere, change my BIOS settings to activate legacy support (otherwise it would not boot), then start the BIOS update utility. Those were some tense 30 seconds. Afterwards, it rebooted into Windows, which I exited, rebooting again only to find out that either the Windows or the BIOS update had somehow mangled my grub partitions. With a vivid USB stick, I was able to make it boot again.

Long story short, the error reappeared promptly. So, now I'm on 8DCN40WW (and we can probably remove the BIOS-outdated tag).

I'm going to do some more testing, perhaps upgrading to vivid.

Brian Burch (brian-pingtoo) wrote :

Thanks for your helpful comment Christopher.

However, I am inclined to believe the symptoms I've reported here are not connected to my original bug report (https://bugs.launchpad.net/ubuntu/+source/bcmwl/+bug/1360783).

I continue to think my symptoms are either related to this current bug, or represent yet another bug. Given the fact that we are patching a version of bcmwl-kernel-source that has not yet been officially released for a production version of ubuntu, I will stay out of this discussion for the moment. If my symptoms prove to be relevant, then at least they are documented here (already) for the developers to consider.

As a lower priority task, I will also set up a test vivid system and see what happens in my particular environment.

1 comments hidden view all 101 comments
Andre Bogus (bogusandre) wrote :

Christopher M. Penalver, the output is:

8DCN40WW
10/24/2014

Interestingly, the version coincides with the version information on the Lenovo site (where I downloaded the update), but the date is one day and one month earlier than the date on the Lenovo site.

Upon further testing, the problem persists with or without the patch applied. Please note that in the meantime, I did an apt-get upgrade, which installed the new 3.16.0-30-generic kernel,.

I'm going to try updating to vivid during the next days.

tags: added: latest-bios-8dcn40ww
removed: bios-outdated-8dcn40ww
Sergey Talchuk (tals1975) wrote :

Hi all,

The NULL POINTER patch doesn't work for me (

$lspci -vvnn | grep -A 9 Network
07:00.0 Network controller [0280]: Broadcom Corporation BCM43142 802.11b/g/n [14e4:4365] (rev 01)
 Subsystem: Foxconn International, Inc. Device [105b:e071]
 Control: I/O- Mem+ BusMaster- SpecCycle- MemWINV- VGASnoop- ParErr- Stepping- SERR- FastB2B- DisINTx-
 Status: Cap+ 66MHz- UDF- FastB2B- ParErr- DEVSEL=fast >TAbort- <TAbort- <MAbort- >SERR- <PERR- INTx-
 Interrupt: pin A routed to IRQ 16
 Region 0: Memory at c0700000 (64-bit, non-prefetchable) [size=32K]
 Capabilities: <access denied>

$lsb_release -rd
Description: Ubuntu 14.10
Release: 14.10

$uname -a
Linux vaio 3.16.0-30-generic #40-Ubuntu SMP Mon Jan 12 22:06:37 UTC 2015 x86_64 x86_64 x86_64 GNU/Linux

$sudo dmidecode -s bios-version
R0220DA

------------[ cut here ]------------
WARNING: CPU: 2 PID: 487 at /build/buildd/linux-3.16.0/net/wireless/sme.c:791 cfg80211_roamed+0x91/0xa0 [cfg80211]()
Modules linked in: pci_stub vboxpci(OE) vboxnetadp(OE) vboxnetflt(OE) vboxdrv(OE) rfcomm bnep snd_hda_codec_hdmi snd_hda_codec_realtek snd_hda_codec_generic binfmt_misc snd_usb_audio snd_usbmidi_lib hid_multitouch hid_generic uvcvideo usbhid hid btusb(OE) bluetooth 6lowpan_iphc videobuf2_vmalloc videobuf2_memops videobuf2_core v4l2_common videodev media microread_mei microread mei_phy crc_ccitt hci nfc wl(POE) intel_rapl x86_pkg_temp_thermal intel_powerclamp kvm_intel kvm crct10dif_pclmul crc32_pclmul snd_hda_intel snd_hda_controller snd_hda_codec snd_hwdep ghash_clmulni_intel aesni_intel snd_pcm aes_x86_64 lrw gf128mul glue_helper snd_seq_midi ablk_helper snd_seq_midi_event cryptd snd_rawmidi joydev serio_raw snd_seq snd_seq_device snd_timer snd rtsx_pci_ms cfg80211 lpc_ich memstick
i915 shpchp soundcore mei_me mei drm_kms_helper drm i2c_algo_bit sony_laptop mac_hid parport_pc video ppdev i2c_i801 coretemp lp parport rtsx_pci_sdmmc psmouse ahci r8169 libahci mii rtsx_pci
CPU: 2 PID: 487 Comm: wl_event_handle Tainted: P OE 3.16.0-30-generic #40-Ubuntu
Hardware name: Sony Corporation SVF15A16CXB/VAIO, BIOS R0220DA 11/18/2013
0000000000000009 ffff880220eafdd0 ffffffff8178236b 0000000000000000
ffff880220eafe08 ffffffff8106feed ffff880220dce000 ffff8801b44c5d80
000000000000009a ffff880039818480 ffff88024334fa78 ffff880220eafe18
Call Trace:
[<ffffffff8178236b>] dump_stack+0x45/0x56
[<ffffffff8106feed>] warn_slowpath_common+0x7d/0xa0
[<ffffffff8106ffca>] warn_slowpath_null+0x1a/0x20
[<ffffffffc03d9981>] cfg80211_roamed+0x91/0xa0 [cfg80211]
[<ffffffffc08c06cb>] wl_notify_roaming_status+0xcb/0x150 [wl]
[<ffffffffc08bd402>] wl_event_handler+0x62/0x260 [wl]
[<ffffffffc08bd3a0>] ? wl_free_wdev.isra.23+0x80/0x80 [wl]
[<ffffffff81094c7b>] kthread+0xdb/0x100
[<ffffffff81094ba0>] ? kthread_create_on_node+0x1c0/0x1c0
[<ffffffff8178a2fc>] ret_from_fork+0x7c/0xb0
[<ffffffff81094ba0>] ? kthread_create_on_node+0x1c0/0x1c0
---[ end trace 741fce72667b8b52 ]---

Andre Bogus (bogusandre) wrote :

That's too bad. I'm one step from updating to vivid. One interesting tidbit I found in dmesg output:

[ 11.564768] wlan0: Broadcom BCM4365 802.11 Hybrid Wireless Controller 6.30.223.248 (r487574)

Is BCM4365 an alias? Or what could be the reason for this?

Sergey Talchuk (tals1975) wrote :

I guess BCM4365 stands here for the deviceID =4365
[14e4:4365]

Andre Bogus (bogusandre) wrote :

Sergey, that is very much possible.

I'm now on vivid (via do-release-upgrade -d), The problem reappears without the patch. I am now reapplying the patch and see if it works out.

Andre Bogus (bogusandre) wrote :

On vivid, with the patch, I still get the warning, but the connection doesn't drop (at least for now, fingers crossed).

tags: added: vivid
1 comments hidden view all 101 comments
Sergey Talchuk (tals1975) wrote :

It might not mean anything... However, the driver works much better with 5GHz devices unlike 2.4GHz (at least for me).

Martin Oemus (martqn) wrote :

I had the same issues like #15, the path here didn't help. I'm still working on trusty. Because the old version worked flawlessly, I downloaded the package 6.30.223.141+bdcom-0ubuntu2 from http://www.ubuntuupdates.org/package/core/trusty/restricted/base/bcmwl-kernel-source and used dpkg to downgrade to this older version. Then I used

sudo apt-mark hold bcmwl-kernel-source

to prevent any problems in the future.

Wolfgang Schupp (wsnipex) wrote :

this patch fixes kernel crashes with kernels >=3.18 for me on BCM43228.
I'm currently using it on top of vivids bcmwl-kernel-source: 6.30.223.248+bdcom-0ubuntu2 and the vivid 3.19.0 kernel

Louis Bouchard (louis) on 2015-03-13
Changed in bcmwl (Ubuntu):
status: Incomplete → In Progress
assignee: nobody → Louis Bouchard (louis-bouchard)
Luis Alvarado (luisalvarado) wrote :

Confirming this issue with the Lenovo Z510. The wireless works randomly. All the problems mentioned here actually happen on this model. Between slow connection, not seeing 5ghz, dropping packets, dropping connection I actually thought I had problems with the laptop but after checking another 5 similar models, all had the same behavior.

I am using Vivid 15.04 and the latest 3.19 kernel version as of right now.

Linux cyrex 3.19.0-9-generic #9-Ubuntu SMP Wed Mar 11 17:50:03 UTC 2015 x86_64 x86_64 x86_64 GNU/Linux

I have not tried the patch yet but will proceed and give feedback.

Sergey Talchuk (tals1975) wrote :

-kernel 3.18.9-031809-generic.
-patch applied.

Much better now. However, crashes still occur:e.g.
-sudo rmmod wl cfg80211
-sudo modprobe wl > results in a crash.

workaround:
-sudo modprobe cfg80211
wait for abount 10 seconds
-sudo modprobe wl

Looking forward to new patches )

Stephen Czetty (stephenczetty) wrote :

This patch worked for me also, but I also had to run update-initramfs.

PierreF (pierre-fersing) wrote :

I have null pointer exception on a XPS 13 (9343) which trigger a kernel panic when I suspend the laptop. I can reproduce the issue nearly all times (3 / 4 tries), for this I need to generate network traffic (looking a video on Internet seem to be enough).

After applying the patch mentioned above, I not longer have such kernel panic (done 6 tries without any kernel panic). So that patch seems to solve my kernel panic issue when suspending laptop.

I will attach the debdiff I used to apply the patch.

Without the patch (with bcmwl-kernel-source 6.30.223.248+bdcom-0ubuntu2), I could product a kernel panic by doing:

* Have network "load" (watching video on internet, downloading something, ...)
* Suspend the laptop. On my test I did it with "systemctl suspend" from tty1 to capture the Call trace.

System information:

* Hardware : Dell XPS 13 (9343)
* Ubuntu 15.04 amd64
* Bios A03 03/25/2015
* bcmwl-kernel-source 6.30.223.248+bdcom-0ubuntu2 (so wifi is using module wl)
* lspci : 02:00.0 Network controller: Broadcom Corporation BCM4352 802.11ac Wireless Network Adapter (rev 03)

I will also attach picture of the screen after a crash + partial transcript the of kernel panic (see picture for the full information).

PierreF (pierre-fersing) wrote :
PierreF (pierre-fersing) wrote :
PierreF (pierre-fersing) wrote :
Paweł (paff) wrote :

This patch fixed my problems.

System information:

* Hardware : HP EliteBook 2570p
* Ubuntu 14.04 amd64
* Bios 68ISB Ver. F.40
* bcmwl-kernel-source 6.30.223.248+bdcom-0ubuntu2
* lspci : Broadcom Corporation BCM43228 802.11a/b/g/n

There were no problems on driver version: 6.30.223.141+bdcom-0ubuntu2, but this I was using with kernel 3.16.
After compiling 3.17 and above I started to use b43 drivers, and there were working unless I was more than 2 meters from AP - then connections was started to drop every couple minutes.

Now Im using kernek 3.19 with "wl" module and this patch and its working.

Blaine (romeda) wrote :

Just to add confirmation that I was seeing the kernel panics on a Dell XPS 13 Developer Edition after upgrading to 15.04 (BIOS A04), and after applying Jesse/PierreF's patch, suspend/resume is now working fine.

Markus W (z-mw) wrote :

The patch from #27 appears to have fixed the kernel panics on suspend for me as well on my Dell XPS 13 Developer Edition (2015 edition) with Ubuntu 15.04 and BIOS A04. Have not seen a panic in five days while before I could not go more than one day without it.

bugmenot (teceko) wrote :

How do I apply this patch? Can anyone specify the entire procedure step by step please?

bugmenot (teceko) on 2015-07-09
Changed in bcmwl (Ubuntu):
status: In Progress → New
status: New → In Progress
Hugo F. (hg8) wrote :

Thanks for this patch !
Does anyone know how to apply this patch under kernel > 4.x ?
Thanks in advance.

monochromec (monochromec) wrote :

Please note that the null pointer crash is only required for kernels >= 3.18. I can confirm that the patch is working on both unicorn and vivid releases.

@Hugo: Just follow the instructions at the beginning of the bug report A somewhat different approach using dkms is described in a duplicate bug report I filed some time ago (https://bugs.launchpad.net/ubuntu/+source/bcmwl/+bug/1451789).

@PierreF: I had similar problems when suspending a MBP (which uses a BCM 4331), albeit the driver would stop working rather then causing a kernel panic upon wake-up. Removing the driver before suspending and inserting it once again upon wake-up did the trick for me. The implementation of this is straight forward: just put a similar script to the following in /lib/systemd/system-sleep

#!/bin/bash
MA=$(uname -r | awk -F'.' '{ print $1 }')
if [ $MA -ge 4 ] ; then
    if [ $1 = pre ] ; then
 rmmod wl
    else
 modprobe wl
    fi
fi

Cf. for the systemd power management documentation for the details.

Changed in dell-sputnik:
status: New → Confirmed
Changed in bcmwl (Ubuntu):
assignee: Louis Bouchard (louis-bouchard) → Rafael David Tinoco (inaddy)
2 comments hidden view all 101 comments
Rafael David Tinoco (inaddy) wrote :

Okay, so after reading all the bug I have the following summary:

"""
1. The current trusty repository bcmwl-kernel-source 6.30.223.141+bdcom-0ubuntu2 is used on my wife's laptop. This system is not experiencing null pointer crashes OR Scan_results errors. This evidence strongly suggests both problems were introduced with 6.30.223.248+bdcom-0ubuntu1.
"""

We have a problem introduced in between:

bcmwl-kernel-source | 6.30.223.141+bdcom-0ubuntu2

and

bcmwl-kernel-source | 6.30.223.248+bdcom-0ubuntu0.1
bcmwl-kernel-source | 6.30.223.248+bdcom-0ubuntu2
bcmwl-kernel-source | 6.30.223.248+bdcom-0ubuntu4

"""
2. On checking syslog carefully, the Scan_results errors are often associated with the system running slowly and "[TTM] Out of kernel memory" messages being logged.

https://bugs.launchpad.net/ubuntu/+source/bcmwl/+bug/1415880/comments/15

I'm now on vivid (via do-release-upgrade -d), The problem reappears without the patch. I am now reapplying the patch and see if it works out. On vivid, with the patch, I still get the warning, but the connection doesn't drop (at least for now, fingers crossed).

this patch fixes kernel crashes with kernels >=3.18 for me on BCM43228.
I'm currently using it on top of vivids bcmwl-kernel-source: 6.30.223.248+bdcom-0ubuntu2 and the vivid 3.19.0 kernel
"""

It looks like the patch fixes the out of memory problem.

"""
-kernel 3.18.9-031809-generic.
-patch applied.

Much better now. However, crashes still occur:e.g.
-sudo rmmod wl cfg80211
-sudo modprobe wl > results in a crash.

workaround:
-sudo modprobe cfg80211
wait for abount 10 seconds
-sudo modprobe wl
"""

But still there is a minor problem with "suspension".

"""
Just to add confirmation that I was seeing the kernel panics on a Dell XPS 13 Developer Edition after upgrading to 15.04 (BIOS A04), and after applying Jesse/PierreF's patch, suspend/resume is now working fine.

The patch from #27 appears to have fixed the kernel panics on suspend for me as well on my Dell XPS 13 Developer Edition (2015 edition) with Ubuntu 15.04 and BIOS A04. Have not seen a panic in five days while before I could not go more than one day without it.
"""

I'll be providing a PPA with the fix and asking for feedback. If the suspend problems still occur we will continue from there. Expect a PPA provided here soon. BTW, I'll provide fixes for Vivid only since Utopic is not supported anymore.

Thank you

Rafael Tinoco
SEG Team

tags: added: iso-testing
21 comments hidden view all 101 comments
Rafael David Tinoco (inaddy) wrote :

I've subscribed Ubuntu Sponsors team seeking for sponsorship on Precise (Updates), Trusty, Vivid and Wily fixes (attached to this case). Let me know if I can assist with anything else.

Best Regards

Rafael Tinoco

description: updated
Martin Oemus (martqn) wrote :

For a while I stopped using suspend and it seemed promising, but today I experienced problems directly after booting.

1)
I'm afraid the log I posted earlier was not very meaningful. I triggered the behaviour by closing the lid of my laptop because this was a way to safely reproduce the issues. This seems to be a physical problem of my laptop. Probably the wifi antenna gets shielded when the lid is closed. In Windows 7 connection quality drops significantly and bandwidth goes down to 300 KB/s. In Linux the connection goes down completely (ping says Network is unreachable), produces the messages I posted earlier, including the call traces.
As annyoing as this is, it is probably nothing we can do anything about. The driver might not work as efficient as in Windows but that's it.

2)
----
This only means that broadcom WL driver tried to warn kernel that it roamed from one AP to another and new BSS could not be found (meaning that the card could not get all its new BSS - peers, APs, etc).
----
My network consists only of one BSS (router), but I tried it anyway. I set the mac address of my router in the BSSID field in the networkmanager interface. This didn't change anything at all, I still got call traces, indicating, according to you, failed roaming attempts.

3)
I attached the syslog from this morning. The problems start at 11:40:16 with 2 call traces. At 11:40:57 wpa_supplicant gives CTRL-EVENT-ASSOC-REJECT messages. Google recommends blacklisting certain modules, but none of them are loaded on my system. Another call trace follows and networkmanager says it's disconnected. It goes on a bit and finally re-establishes the connection. This seems to be more or less stable for already two hours or so.

I really don't know what to make of this. I can't see a distinct pattern. I'm not dependent on Wifi, so it's not a big deal.
Yet I'm still interested in solving this issue. My next step would be to test the whole thing without networkmanager and see how things are then because I think networkmanager really complicates debugging this. I wanted to explicitely set wpa_supplicant to use WPA2-CCMP only because in some setups I experienced connection problems when this wasn't explicitely set, but networkmanager doesn't offer me a way to do this.

Chris J Arges (arges) wrote :

Sponsored for Wily.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package bcmwl - 6.30.223.248+bdcom-0ubuntu4.1

---------------
bcmwl (6.30.223.248+bdcom-0ubuntu4.1) wily; urgency=medium

  * Added needed patches for lts kernels (LP: #1415880)
  * Fixed null pointer reference (LP: #1415880)
    d/p/0019-broadcom-sta-6.30.223.248-3.18-null-pointer-fix.patch

 -- Rafael David Tinoco <email address hidden> Thu, 10 Sep 2015 10:42:38 -0500

Changed in bcmwl (Ubuntu):
status: In Progress → Fix Released

Is there a sponsor for trusty or vivid?

Brian Burch (brian-pingtoo) wrote :

Just a personal update.

I've been using a manually patched version of the i386 driver for several months, but I only use up to 0014-null-pointer-crash.patch. I currently have the trusty 3.13.0.-63.103-lowlatency kernel on a dell 1558 and the BCM4315. I haven't seen another null pointer crash since I applied the patch, but have suffered random loss of wifi synchronisation, sometimes after a day or so, but other times every hour or even less.

I didn't expect to see a difference, but I thought it was worth saying that I successfully applied the just-released wily package bcmwl-kernel-source_6.30.223.248+bdcom-0ubuntu4.1_i386.deb to my trusty system. The build was clean (logged "using CFG80211 API") and the driver loads without a problem.

I haven't been using it long enough to say whether it is better, but it is definitely no worse!

Rafael David Tinoco (inaddy) wrote :

Daniel,

SRUs are done from Development versions to more stable ones. This way we can guarantee that LTS versions are good (even more than just relying on verification process). It might take awhile for Trusty and Vivid to get sponsored.

Brian,

Thank you very much for the feedback.

ser (seanerussell) wrote :

Just a note to confirm that wily's bcmwl-kernel-source_6.30.223.248+bdcom-0ubuntu4.1_amd64.deb works a treat. I've been running it for a few days now, and I've gotten to the point where I trust it enough to close the lid even when walking to a nearby conference room a couple of seconds away. I haven't had a single panic since installing the package.

Absolutely beautiful.

Any of you noticed a decreasing signal with this driver, with the same machine and os (Ubuntu 14.04) i had a decrease on wifi signal (and wifi is still the same i checked it) any of you noticed about this?

monochromec (monochromec) wrote :

In case you are running on problems with the NetworkManager (version 1.0.4-ubuntu5) after the official upgrade to Wily (messages "[platform/nm-linux-platform.c:2782] do_change_link(): platform-linux: do-change-link: failure changing link 4: No such device (31)" or similar) after wakeup from a suspend, simply restart the NetworkManager with a suitable script in /lib/systemd/system-sleep in order to get autoconnect working again.

Chris J Arges (arges) on 2016-01-04
Changed in bcmwl (Ubuntu Wily):
status: New → Fix Released
Chris J Arges (arges) wrote :

Sponsored P/V versions.

Rafael David Tinoco (inaddy) wrote :

## Precise debdiff applies cleanly.

## Trusty is already fixed in -proposed (same fixes)

bcmwl (6.30.223.248+bdcom-0ubuntu0.2) trusty-proposed; urgency=medium

  * debian/dkms.conf.in,
    0016-repair-make-warnings.patch,
    0017-add-support-for-Linux-4.0.patch,
    0018-cfg80211_disconnected.patch,
    0019-broadcom-sta-6.30.223.248-3.18-null-pointer-fix.patch:
    - Add support for kernels up to 4.2 (LP: #1518956). Credit
      for the patches goes to Krzysztof Kolasa and to Tim Gardner.

 -- Alberto Milone <email address hidden> Fri, 27 Nov 2015 18:02:04 +0100

## Vivid debdiff applies cleanly.

## Wily is already fix released:

bcmwl (6.30.223.248+bdcom-0ubuntu4.1) wily; urgency=medium

  * Added needed patches for lts kernels (LP: #1415880)
  * Fixed null pointer reference (LP: #1415880)
    d/p/0019-broadcom-sta-6.30.223.248-3.18-null-pointer-fix.patch

 -- Rafael David Tinoco <email address hidden> Thu, 10 Sep 2015 10:42:38 -0500

## Xenial is already fix released:

bcmwl (6.30.223.248+bdcom-0ubuntu4.1) wily; urgency=medium

  * Added needed patches for lts kernels (LP: #1415880)
  * Fixed null pointer reference (LP: #1415880)
    d/p/0019-broadcom-sta-6.30.223.248-3.18-null-pointer-fix.patch

 -- Rafael David Tinoco <email address hidden> Thu, 10 Sep 2015 10:42:38 -0500

Changed in bcmwl (Ubuntu Trusty):
status: New → Fix Committed
Changed in bcmwl (Ubuntu Precise):
assignee: nobody → Rafael David Tinoco (inaddy)
Changed in bcmwl (Ubuntu Trusty):
assignee: nobody → Rafael David Tinoco (inaddy)
Changed in bcmwl (Ubuntu Vivid):
assignee: nobody → Rafael David Tinoco (inaddy)
Changed in bcmwl (Ubuntu Wily):
assignee: nobody → Rafael David Tinoco (inaddy)
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in bcmwl (Ubuntu Precise):
status: New → Confirmed
Changed in bcmwl (Ubuntu Vivid):
status: New → Confirmed
Changed in bcmwl (Ubuntu Precise):
importance: Undecided → High
Changed in bcmwl (Ubuntu Trusty):
importance: Undecided → High
Changed in bcmwl (Ubuntu Vivid):
importance: Undecided → High
Changed in bcmwl (Ubuntu Wily):
importance: Undecided → High
1 comments hidden view all 101 comments

Hello Andre, or anyone else affected,

Accepted bcmwl into vivid-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/bcmwl/6.30.223.248+bdcom-0ubuntu2.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in bcmwl (Ubuntu Vivid):
status: Confirmed → Fix Committed
tags: added: verification-needed
Changed in bcmwl (Ubuntu Precise):
status: Confirmed → Fix Committed
Brian Murray (brian-murray) wrote :

Hello Andre, or anyone else affected,

Accepted bcmwl into precise-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/bcmwl/6.30.223.248+bdcom-0ubuntu0.0.3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Can anyone confirm that https://launchpad.net/ubuntu/+source/bcmwl/6.30.223.248+bdcom-0ubuntu0.0.3 fixes problem?
I just tried this package and I have still same problem - laptop don't want to back to work after suspend (Dell XPS 15 9530)

Arun kumar (arunsori94) wrote :

I've this version of the driver (https://launchpad.net/ubuntu/wily/amd64/bcmwl-kernel-source/6.30.223.248+bdcom-0ubuntu7) installed on dell inspiron 5520 which has same BCM43142 WIFI adapter. I'm having the same problem with the latest version of the package installed on ubuntun 15.10.
Followed recommendations to fix wifi adapter to a fixed Access Point but still it is roaming and gets disconnected after an interval of time.
Any updates on this ?

One of my clients has a laptop with the BCM43142 running Ubuntu 14.04 (kernel 3.16) with this patch applied. It unfortunately does not solve the issue. Random disconnects after some time continue.

Just checked with Ubuntu 16.04 and Dell XPS 15 9530 - still same problem.

I have some workaround (distable/enable wl module when suspend)

- check this http://askubuntu.com/questions/620494/ubuntu-15-04-suspend-doesnt-run-pm-suspend (needed for 15.04 or higher)
- in /etc/pm/sleep.d create file with some name (for example 01_wifi_wl) with content:

=========================
#!/bin/bash

case "$1" in
    suspend)
 modprobe -r wl
        ;;
    resume)
 modprobe wl
        ;;
    *)
        ;;
esac
=========================

The version of bcmwl in the proposed pocket of Vivid that was purported to fix this bug report has been removed because the bugs that were to be fixed by the upload were not verified in a timely (105 days) fashion.

Changed in bcmwl (Ubuntu Vivid):
status: Fix Committed → Won't Fix
4 comments hidden view all 101 comments
Mathew Hodson (mathew-hodson) wrote :

I believe this bug was fixed i Trusty with Bug #1518956

There isn't currently a bcmwl package in trusty-proposed.

no longer affects: bcmwl (Ubuntu Trusty)
Mathew Hodson (mathew-hodson) wrote :

I accidentally removed the Trusty task, but I think it should be marked fix released instead.

Dmitry Mazur (dime-m) wrote :

Hi, don't know where to post this (and my English is not so good, sorry), but: i have the same problems with my bcm43142 (HP G4 250 laptop) + (4.4.0-24-generic #43-Ubuntu 16.04 64'bit' GNU/Linux) - it drops connections per "any random time". Today (after many days of wifipain) I've seem that ping drop so many packages, BUT not for the first time - ONLY when u start ping anywhere for the second time after `modprobe or .. wifi goes on?` ! So i have decided to check if terminal will always ping ( * my router ip, cause don't be banned by anybody, of couse) and what i've seen: NO DROPPING while pinging. at all. (also packets AND wifi connection i mean + wifi signal meters "don't jump"). (64 bytes from 192.168.10.1: icmp_seq=6338 ttl=64 time=0.628 ms). but. Before this i disabled ipv6 and don't change it back.. Tomorrow will check with ipv6 and other options.. I know this is not a cure, but it's working for me. What do next if i can help?

Karen Corrick (kcorr) wrote :

This is not a simple process for new ubuntu users. Where do I get the patch file? Where is it? Every time I click on "choose" by package, I get a clickable item, click on it, but then nothing happens. How do I do the following???
Adding the patch is a fairly simple process:
* put the patch file in /usr/src/bcmwl-6.30.223.248+bdcom/patches

Karen Corrick (kcorr) wrote :

I found the patch, but I'm using Ubuntu 16.04 LTS and there is no such directory as specified below (the place where I'm supposed to put this patch). What to do?

monochromec (monochromec) wrote :

Hi Karen,

The location of the patch directory is as outlined above on 16.04. Please
double-check that you have installed the correct version of the package (this should
be 6.30.223.248+bdcom). Otherwise, please post the contents of your /usr/src directory to progress
this further.

GBiradar (gbiradar) wrote :
Download full text (12.9 KiB)

Hi Guys,

i'm facing same problem BCM43142 driver is crashing i already open bug but so far i didn't get necessary help to resolve the issue,

I faced the same problem in ubuntu 14.04 so upgraded to ubuntu 16.04 but still my wifi chipset connects and disconnects after some time, please check the crash log,

[ 69.780612] usb 1-1.4: new full-speed USB device number 4 using ehci-pci
[ 69.875757] usb 1-1.4: New USB device found, idVendor=0a5c, idProduct=21d7
[ 69.875763] usb 1-1.4: New USB device strings: Mfr=1, Product=2, SerialNumber=3
[ 69.875767] usb 1-1.4: Product: BCM43142A0
[ 69.875770] usb 1-1.4: Manufacturer: Broadcom Corp
[ 69.875772] usb 1-1.4: SerialNumber: 9C2A70D0CA3A
[ 70.196820] Bluetooth: Core ver 2.21
[ 70.196840] NET: Registered protocol family 31
[ 70.196841] Bluetooth: HCI device and connection manager initialized
[ 70.196845] Bluetooth: HCI socket layer initialized
[ 70.196847] Bluetooth: L2CAP socket layer initialized
[ 70.196852] Bluetooth: SCO socket layer initialized
[ 70.596642] usbcore: registered new interface driver btusb
[ 70.603752] Bluetooth: hci0: BCM: chip id 70
[ 70.619654] Bluetooth: hci0: BCM43142A
[ 70.619664] Bluetooth: hci0: BCM (001.001.011) build 0000
[ 70.652707] bluetooth hci0: Direct firmware load for brcm/BCM.hcd failed with error -2
[ 70.652714] Bluetooth: hci0: BCM: Patch brcm/BCM.hcd not found
[ 72.656604] Bluetooth: hci0 command 0x1003 tx timeout
[ 73.450154] Bluetooth: BNEP (Ethernet Emulation) ver 1.3
[ 73.450158] Bluetooth: BNEP filters: protocol multicast
[ 73.450164] Bluetooth: BNEP socket layer initialized
[ 73.651455] Bluetooth: RFCOMM TTY layer initialized
[ 73.651465] Bluetooth: RFCOMM socket layer initialized
[ 73.651471] Bluetooth: RFCOMM ver 1.11
[ 288.406323] ------------[ cut here ]------------
[ 288.406349] WARNING: CPU: 2 PID: 439 at /build/linux-R0TiM8/linux-4.4.0/net/wireless/sme.c:850 cfg80211_roamed+0x86/0xa0 [cfg80211]()
[ 288.406350] Modules linked in: rfcomm bnep btusb btrtl btbcm btintel bluetooth binfmt_misc nls_iso8859_1 wl(POE) snd_hda_codec_hdmi snd_hda_codec_cirrus snd_hda_codec_generic snd_hda_intel snd_hda_codec uvcvideo snd_hda_core intel_rapl videobuf2_vmalloc videobuf2_memops x86_pkg_temp_thermal intel_powerclamp videobuf2_v4l2 videobuf2_core coretemp v4l2_common snd_hwdep kvm_intel snd_pcm videodev snd_seq_midi snd_seq_midi_event snd_rawmidi snd_seq media snd_seq_device snd_timer dell_wmi mei_me sparse_keymap kvm cfg80211 snd mei dell_laptop irqbypass crct10dif_pclmul dcdbas dell_smm_hwmon input_leds crc32_pclmul shpchp serio_raw soundcore cryptd mac_hid lpc_ich parport_pc ppdev lp parport autofs4 ums_realtek uas usb_storage i915 i2c_algo_bit drm_kms_helper syscopyarea sysfillrect ahci sysimgblt fb_sys_fops
[ 288.406388] libahci drm psmouse r8169 mii wmi video fjes
[ 288.406395] CPU: 2 PID: 439 Comm: wl_event_handle Tainted: P OE 4.4.0-38-generic #57-Ubuntu
[ 288.406396] Hardware name: Dell Inc. Vostro 2520/0V1NDP, BIOS A11 02/24/2014
[ 288.406398] 0000000000000286 00000000ff0b74b0 ffff8800d5f4fdc8 ffffffff813f1b73
[ 288.406401] 0000000000000000 ffffffffc0375bd0 ffff8800d5f4fe00 ffffffff810811c2
[ 288.406403] ffff8800ce8d7000 ffff880119385b40 0000000000000099 ff...

Martin Pitt (pitti) wrote :

The version of bcmwl in the proposed pocket of Precise that was purported to fix this bug report has been removed because the bugs that were to be fixed by the upload were not verified in a timely (105 days) fashion.

Changed in bcmwl (Ubuntu Precise):
status: Fix Committed → Won't Fix

Hello Andre, or anyone else affected,

Accepted bcmwl into trusty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/bcmwl/6.30.223.271+bdcom-0ubuntu1~0.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in bcmwl (Ubuntu Trusty):
status: New → Fix Committed
Changed in bcmwl (Ubuntu Trusty):
importance: Undecided → High

The fix for this bug has been awaiting testing feedback in the -proposed repository for trusty for more than 90 days. Please test this fix and update the bug appropriately with the results. In the event that the fix for this bug is still not verified 15 days from now, the package will be removed from the -proposed repository.

tags: added: removal-candidate
Brian Burch (brian-pingtoo) wrote :

Sorry to say this fix arrived much too late. The system affected is running xenial and doesn't experience these symptoms.

kristian (m-kristian) wrote :

I also have to say that the system where I experienced this error is not with me anymore.

ramiro (haly88) wrote :

Hey guys, i have this issue for tree years now,
i'm using 16.04 now, What should i do? the patch posted above seams not be working.

As part of a recent change in the Stable Release Update verification policy we would like to inform that for a bug to be considered verified for a given release a verification-done-$RELEASE tag needs to be added to the bug where $RELEASE is the name of the series the package that was tested (e.g. verification-done-xenial). Please note that the global 'verification-done' tag can no longer be used for this purpose.

Thank you!

Displaying first 40 and last 40 comments. View all 101 comments or add a comment.